/*
 * wnix, a Unix-like operating system for WebAssembly applications.
 * Copyright (C) 2025  Xavier Del Campo Romero
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#include <aio.h>
#include <fs/fs.h>
#include <aio/types.h>
#include <state.h>
#include <stddef.h>
#include <stdlib.h>

struct write
{
    struct aio_done done;
};

static int done(const enum state s, void *const args)
{
    int ret = 0;
    struct write *const w = args;
    const struct aio_done *const d = &w->done;

    if (d->f)
        ret = d->f(s, d->args);

    free(w);
    return ret;
}

static enum state write_done(void *const args)
{
    return STATE_OK;
}

struct aio *aio_write(const struct fs_write *const fw,
    const struct aio_done *const d)
{
    struct aio *aio = NULL;
    struct write *const w = malloc(sizeof *w);
    struct fs_fd *const fd = fw->fd;
    const struct fs *const fs = fd->mp.fs;

    if (!w || !(aio = malloc(sizeof *aio)))
        goto failure;

    *w = (const struct write){0};
    *aio = (const struct aio)
    {
        .r.f = write_done,
        .done =
        {
            .f = done,
            .args = w
        }
    };

    if (fs->write(fw, &aio->r))
        goto failure;
    else if (d)
        w->done = *d;

    return aio;

failure:
    free(w);
    free(aio);
    return NULL;
}
